<template>
  <div>
    <!-- Modification Adresses -->
    <div v-if="action == 'adresse'">
      <h3 class="h4 mb-4">Données personnelles</h3>
      <b-card-group deck class="mb-5">
        <b-card header-tag="header" v-if="!showEditInfos">
          <template #header>
            <h5 class="mb-0">Contact</h5>
          </template>
          <b-card-text>
            {{ clientStore.infoClient.civilite }}&nbsp; {{ clientStore.infoClient.name }}&nbsp; {{ clientStore.infoClient.firstName }}<br />
            Né le {{ clientStore.infoClient.dateOfBirth }}
            <br />
            <font-awesome-icon icon="envelope" /> {{ clientStore.infoClient.email }}<br />
            <font-awesome-icon icon="phone-alt" /> {{ clientStore.infoClient.phoneNumber }}
          </b-card-text>

          <b-button variant="outline-default" @click="showFormEditInfos('infosclient')"><font-awesome-icon icon="edit" /> Modifier</b-button>
        </b-card>

        <!-- Formulaire d'édition infos client -->
        <b-card header-tag="header" v-if="showEditInfos">
          <template #header>
            <h5 class="mb-0">Contact</h5>
          </template>
          <b-card-text>
            <b-form-group id="fieldset-1" label="Civilité" label-for="input-1">
              <b-form-radio-group id="input-1" :options="civilite" name="civilite" v-model="newInfos.civilite"></b-form-radio-group>
            </b-form-group>
            <b-form-group id="fieldset-2" label="Votre nom" label-for="input-2">
              <b-form-input id="input-2" v-model="newInfos.name"></b-form-input>
            </b-form-group>
            <b-form-group id="fieldset-3" label="Votre Prénom" label-for="input-3">
              <b-form-input id="input-3" v-model="newInfos.firstName"></b-form-input>
            </b-form-group>
            <b-form-group id="fieldset-4" label="Votre email" label-for="input-4">
              <b-form-input id="input-4" v-model="newInfos.email" type="email"></b-form-input>
            </b-form-group>
            <b-form-group id="fieldset-5" label="Votre date de naissance" label-for="input-5">
              <b-form-input id="input-5" v-model="newInfos.dateOfBirth" type="date"></b-form-input>
            </b-form-group>
            <b-form-group id="fieldset-6" label="Numéro de téléphone" label-for="input-6">
              <b-form-input id="input-6" v-model="newInfos.phoneNumber" type="tel"></b-form-input>
            </b-form-group>
          </b-card-text>
          <vue-simple-spinner v-if="pending === true"></vue-simple-spinner>
          <b-button v-if="pending === false" variant="outline-default" @click="saveNewInfo()"><font-awesome-icon icon="edit" /> Enregistrer</b-button>
        </b-card>

        <b-card header-tag="header" v-if="!showEditLivraions">
          <template #header>
            <h5 class="mb-0">Adresse(s) de livraison</h5>
          </template>
          <b-card-text>
            {{ clientStore.infoClient.delivery[0].street }}<br />
            {{ clientStore.infoClient.delivery[0].postalCode }} &nbsp; {{ clientStore.infoClient.delivery[0].city }}<br />
            {{ clientStore.infoClient.delivery[0].country }}<br />
          </b-card-text>
          <b-button variant="outline-default" @click="showFormEditInfos('livraison')"><font-awesome-icon icon="edit" /> Changer l'adresse</b-button>
        </b-card>

        <!-- Formulaire d'edition adresse de livraison -->

        <b-card header-tag="header" v-if="showEditLivraions">
          <template #header>
            <h5 class="mb-0">Adresse(s) de livraison</h5>
          </template>
          <b-card-text>
            <b-form-group id="fieldset-7" label="Votre rue" label-for="input-7">
              <b-form-input id="input-7" v-model="newInfosLivraison.street"></b-form-input>
            </b-form-group>
            <b-form-group id="fieldset-8" label="Votre code postal" label-for="input-8">
              <b-form-input id="input-8" v-model="newInfosLivraison.postalCode"></b-form-input>
            </b-form-group>
            <b-form-group id="fieldset-9" label="Votre ville" label-for="input-9">
              <b-form-input id="input-9" v-model="newInfosLivraison.city"></b-form-input>
            </b-form-group>

            <b-form-group id="fieldset-10" label="Votre pays" label-for="input-10">
              <b-form-input id="input-10" v-model="newInfosLivraison.country"></b-form-input>
            </b-form-group>
          </b-card-text>
          <vue-simple-spinner v-if="pending === true"></vue-simple-spinner>
          <b-button v-if="pending === false" variant="outline-default" @click="saveLivraison(0)"><font-awesome-icon icon="edit" /> Enregistrer</b-button>
        </b-card>
      </b-card-group>
    </div>

    <!-- Modification mot de passe -->
    <div v-if="action == 'password'">
      <div class="log-panel">
        <form>
          <h3 class="h4 mb-3">Modification du mot de passe</h3>
          <div v-html="messageClient" class="alert alert-warning" role="alert" v-if="messageClient">
            {{ messageClient }}
          </div>
          <div class="form-group">
            <label>Mot de passe actuel</label>
            <input type="password" class="form-control form-control-lg" v-model="newPassword.old" />
          </div>

          <div class="form-group">
            <label>Nouveau mot de passe</label>
            <input type="password" class="form-control form-control-lg" v-model="newPassword.new" />
          </div>

          <div class="form-group">
            <label>Confirmation</label>
            <input type="password" class="form-control form-control-lg" v-model="newPassword.confirmNew" />
          </div>
          <vue-simple-spinner v-if="pending === true"></vue-simple-spinner>
          <b-button v-if="pending === false" block variant="dark" size="lg" @click="modiFyPassword()">Modifier</b-button>
        </form>
      </div>
    </div>

    <!-- Suppression compte -->
    <div v-if="action == 'suppression'">
      <div class="log-panel">
        <form>
          <div v-html="messageClient" class="alert alert-warning" role="alert" v-if="messageClient">
            {{ messageClient }}
          </div>
          <h4 class="mb-3">Effacer son compte de façon permanente</h4>
          <p>Nous sommes désolé d'apprendre que vous souhaitez nous quitter.</p>
          <p>
            Si vous souhaitez supprimer complètement votre compte, rappelez-vous que vous ne pourrez ni réactiver votre compte ni récupérer son contenu ou ses informations. De plus vous ne recevrez plus notre newsletter et nos offres promotionnelles.
          </p>
          <p>
            Nous conserverons toute fois certaines données personnelles : <br />
            <a href="#">voir notre politique de confidentialité</a>.
          </p>

          <div class="form-group">
            <label>Mot de passe</label>
            <input type="password" class="form-control form-control-lg" v-model="passWordToDelete" />
          </div>
          <vue-simple-spinner v-if="pending === true"></vue-simple-spinner>
          <b-button v-if="pending === false" block variant="danger" size="lg" @click="deleteAccount()">Supprimer le compte</b-button>
        </form>
      </div>
    </div>
  </div>
</template>
<script>
import store from "../../store";

const URL_API = process.env.VUE_APP_URL_DISTANT_API + "/api/";
export default {
  mounted: function() {
    // this.fetchInfosClient();
    console.log("clientStore", this.clientStore);
  },
  props: ["action", "clientStore"],
  data() {
    return {
      showEditInfos: false,
      showEditLivraions: false,
      pending: false,
      messageClient: null,
      civilite: [{ text: "Mme", value: "Mme" }, { text: "Mlle", value: "Mlle" }, { text: "Mr", value: "Mr" }, { text: "Mr et Mme", value: "Mr-Mme" }],
      idClient: this.clientStore.clientId,
      newInfos: {
        name: "",
        firstName: "",
        civilite: "",
        dateOfBirth: "",
        email: "",
        phoneNumber: ""
      },
      newInfosLivraison: {
        street: "",
        postalCode: "",
        city: "",
        country: ""
      },
      newPassword: {
        old: "",
        new: "",
        confirmNew: ""
      },
      passWordToDelete: ""
    };
  },
  methods: {
    showFormEditInfos(whichForm) {
      if (whichForm == "infosclient") {
        this.newInfos = Object.assign({}, this.clientStore.infoClient);
        this.showEditInfos = true;
      } else if (whichForm == "livraison") {
        this.newInfosLivraison = Object.assign({}, this.clientStore.infoClient.delivery[0]);
        this.showEditLivraions = true;
      }
    },
    saveNewInfo() {
      this.pending = true;
      let payload = {"data" : this.newInfos}
      console.log(this.newInfos);
      this.$axios.put(URL_API + "clients/edit/" + this.idClient, payload ).then( response => {
          store.dispatch("updateClient", { 'newInfos': this.newInfos })
          this.pending = false;
          this.showEditInfos = false;
        }
      )
    },
    saveLivraison(indiceAdresse) {
      this.pending = true;
      // update store client
      let payload = {"data" : {
          "name": this.clientStore.infoClient.name,
          "nafPRO": this.clientStore.infoClient.nafPRO,
          "siretPRO": this.clientStore.infoClient.siretPRO,
          "companyNamePRO": this.clientStore.infoClient.companyNamePRO,
          "firstname": this.clientStore.infoClient.firstName,
          "civilite": this.clientStore.infoClient.civilite,
          "delivery": [this.newInfosLivraison],
          "dateOfBirth": this.clientStore.infoClient.dateOfBirth,
          "phoneNumber": this.clientStore.infoClient.phoneNumber
        }
      }
      console.log(this.newInfosLivraison);
      this.$axios.put(URL_API + "clients/edit-livraison/" + this.idClient, payload ).then( response => {
          store.dispatch("updateClientLivraison", { 'newInfosLivraison': this.newInfosLivraison })
          this.pending = false;
          this.showEditLivraions = false;
        }
      )
    },
    modiFyPassword() {
      if (this.newPassword.new === this.newPassword.confirmNew) {
        this.pending = true;
        let payload = {
          oldPassword: this.newPassword.old,
          newPassword: this.newPassword.new
        }
        this.$axios.put(URL_API + "clients/edit-password/" + this.idClient, payload ).then( response => {
            this.pending = false;
            this.messageClient = "Votre mot de passe a bien été changer !"
            this.newPassword = {}
          }
        ).catch(e => {
          this.pending = false;
          this.messageClient = "Veuillez renseigner votre mot de passe actuel !"
          console.log(e)
        })
      } else {
        this.messageClient = "Les champs Nouveau mot de passe et Confimation doivent être identique !"
      }

    },
    deleteAccount() {
      this.pending = true;
      let payload = {
        password: this.passWordToDelete
      }
      this.$axios.post(URL_API + "clients/delete/" + this.idClient, payload ).then( response => {
          this.pending = false;
          this.messageClient = "Votre compte a bien été supprimer !"
          store.dispatch("logout");
          localStorage.removeItem("authUserClient");
          localStorage.removeItem("infoClient");
          this.$router.push("/")
        }
      ).catch(e => {
        this.pending = false;
        this.messageClient = "Veuillez renseigner votre mot de passe actuel !"
        console.log(e)
      })
    }
  }
};
</script>
